drop table if exists users;

create table users (
userid INT NOT NULL AUTO_INCREMENT PRIMARY KEY,
login VARCHAR(50) NOT NULL,
firstname VARCHAR(50),
lastname VARCHAR(50),
email VARCHAR(80),
privateemail BOOLEAN DEFAULT true,
salt CHAR(50) NOT NULL,
shapass CHAR(128) NOT NULL,
status ENUM("unchecked", "ok", "ex") DEFAULT "ok",
creationtime DATETIME
);

drop table if exists groups;
create table groups (
groupid INT NOT NULL AUTO_INCREMENT PRIMARY KEY,
name VARCHAR(50) NOT NULL,
description TEXT,
public BOOLEAN DEFAULT true,
creatorid INT NOT NULL,  
creationtime DATETIME
);

drop table if exists members;
create table members (
userid INT NOT NULL,
groupid INT NOT NULL,
status ENUM("creator","admin", "member", "exmember") NOT NULL
);


-- voters is a python list of users
drop table if exists scrutin;
create table scrutin (
scrutinid INT NOT NULL AUTO_INCREMENT PRIMARY KEY,
title VARCHAR(50),
description TEXT, 
comment TEXT, 
creatorId INT NOT NULL, 
registeredOnly BOOL,
status ENUM("invalid", "valid", "open", "closed"), 
openDate DATETIME, 
closeDate DATETIME
);

-- On remplace la table answers par une liste python dans le champ answers
drop table if exists question;
create table question (
questionid INT NOT NULL AUTO_INCREMENT PRIMARY KEY,
scrutinid INT NOT NULL,
idx INT,
title VARCHAR(100),
description TEXT,
type ENUM("Select", "Choose", "Rate", "Order"),
algo VARCHAR(100),
answers TEXT
);

drop table if exists votes;
create table votes (
voteid INT NOT NULL AUTO_INCREMENT PRIMARY KEY,
scrutinid INT NOT NULL,
answers TEXT
);

drop table if exists voteregister;
create table voteregister (
scrutinid INT NOT NULL,
userid INT NOT NULL,
voteid INT DEFAULT NULL
);

drop table if exists results;
create table results (
scrutinid INT NOT NULL,
results TEXT,
explanation TEXT,
winners TEXT
);

