# -*- coding: utf-8 -*-

# Copyright 2009-2010 Manik Bhattacharjee (manik-listes at altern.org)
#                                                                
# This file is part of PyVotons!.                                
#                                                                
# PyVotons! is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or   
# (at your option) any later version.                                 
#                                                                     
# PyVotons! is distributed in the hope that it will be useful,        
# but WITHOUT ANY WARRANTY; without even the implied warranty of      
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       
# GNU Affero General Public License for more details.                        
#                                                                     
# You should have received a copy of the GNU Affero General Public License   
# along with PyVotons!.  If not, see <http://www.gnu.org/licenses/>. 



from mod_python import Session, apache
from simplejson import loads, dumps

# Careful  : all these functions work on user input (provided by the browser), error=None, id=session['hits']
# This is a security-critical part of the code : all input must be checked

def authenticate(json):
    return {'status':-1}
    
def createUser(json):
    return {'status':-1}
   
def updateUser(json):
    return {'status':-1}

def createScrutin(json):
    return {'status':-1}
   
def rightsUserGroups(json):
    return {'status':-1}

# Request types
   # 1. authentication
   # 2. newUser
   # 3. newScrutin
   # 4. getScrutin
   # 5. updateScrutin
   # 6. getVoteTemplate
   # 7. checkAndRegisterVote
   # 8. getVoteResults -> can trigger computation 
   # 9. ListScrutins (all visible, votables, results...)
   # 10. UserGroupManagement
requestHandlers = {             'Auth':authenticate,\
                                'CreateUser':createUser, \
                                'CreateScrutin':createScrutin, \
                                'GetScrutin':getScrutin, \
                                'UpdateScrutin':updateScrutin, \
                                'GetVoteTemplate':getVoteTemplate,\
                                'CheckAndRegisterVote':checkAndRegisterVote, \
                                'GetResults':getResults,\
                                'ListScrutins':listScrutin,\
                                'UserGroupManagement':userGroupManagement
                                }

def handler(req):
    session = Session.Session(req)

   # Careful ! If this is not a valid json request, just return an error
    try:
       json = loads(req.read())
    except:
        return apache.DECLINED
       
   # Check that the request type is valid. If it is, hand out the request to the appropriate function
    if 'requestType' not in json:
       return apache.DECLINED
    if json['requestType'] not in requestHandlers:
        return apache.DECLINED
    # Calling the handler
    output = requestHandlers[json['requestType'] ] (json)
    
    try:
        session['hits'] += 1
    except:
        session['hits'] = 1

    session.save()

    req.content_type = 'text/plain'
    req.write(dumps(output))
    return apache.OK

