# -*- coding: utf-8 -*-    

# Copyright 2009-2010 Manik Bhattacharjee (manik-listes at altern.org)
#                                                                
# This file is part of PyVotons!.                                
#                                                                
# PyVotons! is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or   
# (at your option) any later version.                                 
#                                                                     
# PyVotons! is distributed in the hope that it will be useful,        
# but WITHOUT ANY WARRANTY; without even the implied warranty of      
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       
# GNU Affero General Public License for more details.                        
#                                                                     
# You should have received a copy of the GNU Affero General Public License   
# along with PyVotons!.  If not, see <http://www.gnu.org/licenses/>. 

from pyjamas import Window
from pyjamas.ui.RootPanel import RootPanel
from pyjamas.ui.Button import Button
from pyjamas.ui.HTML import HTML
from pyjamas.ui.VerticalPanel import VerticalPanel
from pyjamas.ui.Grid import Grid
#from pyjamas.ui.FlexTable import FlexTable # Grid is faster and we don't need cells that span multiple columns

from pyvotons.core.event import Event

import pyjd

class ListScrutinPage (VerticalPanel):
    def __init__(self,  mainpanel = None,  token = None,  scrutins=None,  goal=None):
        VerticalPanel.__init__(self,  StyleName="pyv-PageBody")

        if token is None:
            self.token = -1
        else:
            self.token = token
            
        if mainpanel is None:
			Window.alert("AuthPage : mainpanel is not valid !")
			return
        self.mainpanel = mainpanel
        self.goal = goal #What kind of event to send when a scrutin is selected
        table = None
        title = {'toVote':'Cliquer pour voter !', 'toSee':"Cliquer pour éditer", 'toResult':'Cliquer pour consulter les résultats'}
        if scrutins is None:
			self.add(HTML("Pas de scrutin !",  StyleName="pyv-H3Title"))
        else:
			self.add(HTML("Liste des scrutins : "+title[goal],  StyleName="pyv-H3Title"))
			self.scrutins = scrutins
			self.add(self.tableFromScrutins(scrutins))

    def tableFromScrutins(self,  scrutins):
		"""Makes a Grid from a list of scrutin dictionaries"""
		rows = len(scrutins)
		if rows < 1:
			return HTML("No scrutin to display")
		columns = len(scrutins[0])
		keys = scrutins[0].keys()
		print "CLEFS "+repr(keys)
		print "ROWS "+str(rows)+" Cols "+str(columns)
		g=Grid(rows+1, columns,  StyleName='pyv-Table') #Width="100%", BorderWidth="1",
		g.addTableListener(self)
		# Title row
		for i in range(columns):
			g.setHTML(0, i, "<b>"+keys[i]+"</b>")
		#Other rows
		for r in range(1, rows+1):
			for i in range(columns):
				g.setHTML(r, i, str(scrutins[r-1][keys[i]]))
				
		return g
		
    def onCellClicked(self, sender, row, cell):
		# Select the row that was clicked (-1 to account for header row).
		if (row > 0):
			s = self.scrutins[row - 1]
			nextUI = {'toVote':'QuickVote', 'toSee':'updateScrutin', 'toResult':'QuickResult'}[self.goal]
			#Window.alert('Selected scrutin ID : '+str(s['scrutinid']))
			e = Event("UI",  {"goto":nextUI, "token":self.token,  'selectedScrutinid':s['scrutinid']} )
			self.mainpanel.send(e)
