# -*- coding: utf-8 -*-    

# Copyright 2009-2010 Manik Bhattacharjee (manik-listes at altern.org)
#                                                                
# This file is part of PyVotons!.                                
#                                                                
# PyVotons! is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or   
# (at your option) any later version.                                 
#                                                                     
# PyVotons! is distributed in the hope that it will be useful,        
# but WITHOUT ANY WARRANTY; without even the implied warranty of      
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       
# GNU Affero General Public License for more details.                        
#                                                                     
# You should have received a copy of the GNU Affero General Public License   
# along with PyVotons!.  If not, see <http://www.gnu.org/licenses/>. 


# TODO : reorganize the callback of the send function to reduce OnRemoteResponse to the minimum
#              There should be a hashtable of callback functions to call for each request
#               Warning : should be size-limited to avoid denial-of-service attacks
#
#              Implement translation support through gettext module (see http://docs.python.org/library/gettext.html)
#              This will work on the server side, but will pyjamas translate it correctly to javascript ?

# TODO short term : - drag and drop for OrderQuestionPanel
#                    - update scrutin must work
#		     - a LOT of CSS improvements for create Scrutin and others

from pyjamas import Window
from pyjamas import DOM
from pyjamas.ui.RootPanel import RootPanel
from pyjamas.ui.HorizontalPanel import HorizontalPanel
from pyjamas.ui.VerticalPanel import VerticalPanel
from pyjamas.ui.DockPanel import DockPanel
from pyjamas.ui.Button import Button
from pyjamas.ui.Image import Image
from pyjamas.ui import  HasAlignment
from pyjamas.ui.PasswordTextBox import PasswordTextBox
from pyjamas.ui.TextBox import TextBox
from pyjamas.ui.HTML import HTML
from pyjamas.ui.SimplePanel import SimplePanel
from pyjamas.JSONService import JSONProxy

from pyvotons.core.event import Event
from pyvotons.ui.pyjamas import  auth
from pyvotons.ui.pyjamas import  NewUserPage
from pyvotons.ui.pyjamas import  ListScrutinPage
from pyvotons.ui.pyjamas import  CreateScrutinPage
from pyvotons.ui.pyjamas import  QuickVote
from pyvotons.ui.pyjamas import  QuickResult

import pyjd,  time

accessDeniedPanel = HTML("<center><h2>Please log in !</h2></center>")
panel = None



class VoteServiceJSONProxy(JSONProxy):
    def __init__(self):
        JSONProxy.__init__(self, "VoteServerManik.py", ["echo", "status", "request"])




def  loadNewUser(event):
    return NewUserPage.NewUserPage(panel,  event.data["token"])

def  loadAuth(event):
    return auth.AuthPage(panel,  event.data["token"])

def  loadMain(event):
    return MainMenuPage(panel,  event.data["token"])
 
def loadSingleVote(event):
	return QuickVote.QuickVote(panel,  event.data["token"],  event.data['voteid'])

def loadSingleResult(event):
	return QuickResult.QuickResult(panel,  event.data["token"],  event.data['scrutinid'])

def loadScrutins(event):
	return ListScrutinPage.ListScrutinPage(panel,  event.data["token"],  event.data['scrutins'],  event.data['goal'])

def loadNewScrutin(event):
    return CreateScrutinPage.CreateScrutinPage(panel,  event.data["token"])

def loadQuickVote(event):
	# event.data["token"]
	return QuickVote.QuickVote(panel, scrutin=event.data['scrutin'])
	
def loadQuickResult(event):
	return QuickResult.QuickResult(mainpanel=panel, scrutin=event.data['scrutin'])
	
def loadEditScrutin(event):
	return HTML("Edit Scrutin : Not implemented")

class ImageButton(VerticalPanel):
    def __init__(self,  image,  text,  function,  cssStyle="pyv-MainMenuIcon"):
        VerticalPanel.__init__(self,  StyleName=cssStyle)
        img = Image(image)#("images/myImage.jpg")
        img.addClickListener(getattr(self, "onImageClicked"))
        
        self.setHorizontalAlignment(HasAlignment.ALIGN_CENTER)
        self.setWidth(1)
        
        self.add(img)
        #self.add(HTML("<b><font color=blue>"+text+"</font></b><br/>",  StyleName='pyvotonsteststyle'))
        self.add(HTML(text+"<br/>"))
        
        self.function = function
        self.text = text
        self.image = image
        
    def onImageClicked(self):
        if self.function:
          self.function(self)
        

class MainMenuPage(VerticalPanel):
    def __init__(self,  mainpanel = None):
        VerticalPanel.__init__(self,  StyleName="pyv-PageBody") # Size=("100%", "20px"), 
        
        self.mainpanel = mainpanel
        if self.mainpanel.token is None:
            self.add(accessDeniedPanel)
            self.add(ImageButton("images/logout.png", "Entrer", self.login))
            #self.mainpanel.send(Event("UI",  {"goto":"auth",  "token":self.mainpanel.token }))
            return
        #self.setBorderWidth(2)
        self.setSpacing("10px")
        self.setHorizontalAlignment(HasAlignment.ALIGN_CENTER)
    
        # Build the main buttons
        subpanel1 = HorizontalPanel()
        subpanel1.setSpacing("20px")
        subpanel1.add(ImageButton("images/newScrutin.png", "Créer un scrutin", self.createScrutin))
        subpanel1.add(ImageButton("images/myScrutins.png", "Mes scrutins", self.scrutins))
        self.add(subpanel1)
        
        subpanel2 = HorizontalPanel()
        subpanel2.setSpacing("20px")
        subpanel2.add(ImageButton("images/vote.png", "Voter", self.vote))
        subpanel2.add(ImageButton("images/results.png", "Résultats", self.results))
        self.add(subpanel2)
        
        self.add(ImageButton("images/logout.png", "Sortir", self.logout))
        
    def login(self):
        self.mainpanel.send(Event("UI",  {"goto":"auth" ,  "token":self.mainpanel.token}))
        
    def logout(self):
        self.mainpanel.send(Event("authenticate",  {"action":"logout", "token":self.mainpanel.token }))
        #self.mainpanel.send(Event("UI",  {"goto":"auth" ,  "token":self.mainpanel.token}))
        
    def vote(self):
        self.mainpanel.send(Event("listScrutins",  {"token":self.mainpanel.token,  'goal':'toVote' }))
        
    def results(self):
        self.mainpanel.send(Event("listScrutins",  {"token":self.mainpanel.token,  'goal':'toResult' }))
        
    def scrutins(self):
        self.mainpanel.send(Event("listScrutins",  {"token":self.mainpanel.token,  'goal':'toSee' }))
        
    def createScrutin(self):
        self.mainpanel.send(Event("UI",  {"goto":"newScrutin",  "token":self.mainpanel.token }))
        
    
        

class ContainerPanel(DockPanel):
    def __init__(self):
        self.centerPanel = None
        self.token = None
        DockPanel.__init__(self,  Width="100%",  Height="100%", HorizontalAlignment=HasAlignment.ALIGN_CENTER,
                          VerticalAlignment=HasAlignment.ALIGN_MIDDLE,
						  BorderWidth=1, Padding=8)
        self.voteservice = VoteServiceJSONProxy()
        #self.setHorizontalAlignment(HasAlignment.ALIGN_CENTER)
        #self.setVerticalAlignment(HasAlignment.ALIGN_MIDDLE)
        DOM.setStyleAttribute(self.getElement(), "background", "white")
        self.add(HTML("PyVotons!",  StyleName="pyv-MainTitle"),  DockPanel.NORTH)
        self.add(HTML("Chacun sa voix !", StyleName="pyv-MainSubtitle"),  DockPanel.NORTH)
        menuButton = Button("Retour au menu", self.loadMain,  StyleName="pyv-MainMenuButton")
        #menuButton.setStyleName("pyv-MainMenuButton")
        self.add(menuButton,  DockPanel.SOUTH)

        self.status = HTML('',  StyleName="pyv-MainStatus")
        self.add(self.status,  DockPanel.SOUTH)
        
    def setStatus(self, txt):
        self.status.setHTML(txt)
        
    def loadMain(self):
                self.send(Event("UI",  {"goto":"main" ,  "token":self.token}))
                
    def updateCenterPanel(self,  panel):
        if self.centerPanel is not None:
            #Window.alert("UPDATE remove " + str(self.centerPanel)+" with "+repr(panel))
            self.remove(self.centerPanel)
        if panel is not None:
            #Window.alert("Adding center panel "+ repr(panel))
            self.add(panel,  DockPanel.CENTER)
        else:
           Window.alert("Center panel not updated : page does not exist !")
           
        self.centerPanel = panel
    
    def finishCreateUser(self,  reqData,  token,  resp):
		self.setStatus("User "+reqData['login']+ " created successfully")
		time.sleep(1)
		self.token = None
		self.send(Event("UI",  {"goto":"auth", "token":None}) )

    def finishUpdateUser(self,  reqData,  token,  resp):
		self.setStatus("User information updated successfully")
		self.token = token
		time.sleep(1)
		self.send(Event("UI",  {"goto":"main", "token":self.token}) )

    def finishListScrutins(self,  reqData,  token,  resp):
		self.setStatus("List of scrutins received")
		self.token = token
		self.send(Event("UI",  {"goto":"listScrutins", "token":self.token,  'goal':reqData['goal'],  'scrutins':resp['scrutins']}) )

    def finishAuthenticate(self,  reqData,  token,  resp):
		if "action" in reqData:
			if reqData["action"] == "login":
				self.token = token
				panel.send(Event("UI",  {"goto":"main", "token":token}) )
			elif reqData["action"] == "logout":
				self.token = None
				panel.send(Event("UI",  {"goto":"auth", "token":None}) )
			else:
					Window.alert('Authenticate error from server')
					
    def finishCreateScrutin(self,  reqData,  token,  resp):
		if 'scrutinid' in resp:
			self.setStatus("Scrutin created successfully with ID "+str(resp['scrutinid']))
			time.sleep(1)
			self.send(Event("UI",  {"goto":"main", "token":self.token}) )
			
    def finishUpdateScrutin(self,  reqData,  token,  resp):
		self.setStatus("Scrutin created successfully with ID "+str(resp['scrutinid']))
		time.sleep(1)
		self.send(Event("UI",  {"goto":"main", "token":self.token}) )
		
    def finishVote(self,  reqData,  token,  resp):
		self.setStatus("Scrutin created successfully with ID "+str(resp['scrutinid']))
		time.sleep(5)
		self.send(Event("UI",  {"goto":"main", "token":self.token}) )
		
    def finishCheckAndRegisterVote(self,  reqData,  token,  resp):
		self.setStatus('<font color="red"><b>Vote registered successfully</b></font>')
		time.sleep(5)
		self.send(Event("UI",  {"goto":"main", "token":self.token}) )
		
            
    # Response est ce que renvoie le serveur. request_info ?
    def onRemoteResponse(self, response, request_info):
        #self.status.setText("RECEIVED : " + repr(response))
        # This should be acted upon according to the server's answer
        status = response["type"]
        if status == "ok":
			#try:
				{'authenticate':self.finishAuthenticate,  'createUser':self.finishCreateUser,  'updateUser':self.finishUpdateUser,\
		   		'createScrutin':self.finishCreateScrutin, 'listScrutins':self.finishListScrutins,  'registerVote':self.finishVote, \
				'updateScrutin':self.finishUpdateScrutin,  'checkAndRegisterVote':self.finishCheckAndRegisterVote}\
				        [response[u'event']['type']] (response[u'event']['data'], response[u'token'],  response)
			#except:
			#	Window.alert ("unknown ok answer from the server !")
			#return
        elif status =="refused":
            return
        elif status == "error":
            self.setStatus(response['errstr'])
        elif status == "apply":
            event = Event(response["event"]["type"],  response["event"]["data"])
            self.setStatus("APPLY : " + str(event))
            if event.eventtype == "UI" and "goto" in event.data:
                #try:
                    self.setStatus("EVENT type="+event.eventtype+", data[goto]="+event.data['goto'])
                    self.updateCenterPanel ({\
                                         "newuser":loadNewUser,\
                                         "auth":loadAuth,\
                                         "main":loadMain,\
                                         "listScrutins":loadScrutins,\
                                         "newScrutin":loadNewScrutin,\
										'QuickVote':loadQuickVote, \
										'QuickResult':loadQuickResult, \
										'updateScrutin':loadEditScrutin}[str(event.data["goto"])](event) )
                    self.setStatus("")
                #except:
                 #   Window.alert("GOTO exception")
                  #  return
                   
        else:
            self.setStatus("Unknown type of server answer !"+repr(response))
        

    def onRemoteError(self, code, errobj, request_info):
       # onRemoteError gets the HTTP error code or 0 and
       # errobj is an jsonrpc 2.0 error dict:
       #     {
       #       'code': jsonrpc-error-code (integer) ,
       #       'message': jsonrpc-error-message (string) ,
       #       'data' : extra-error-data
       #     }
        message = errobj['message']
        if code != 0:
            self.setStatus("HTTP error %d: %s" % 
                                (code, message))
        else:
            code = errobj['code']
            self.setStatus("JSONRPC Error %s: %s" %
                                (code, message)) 


    def send(self,  event,  receiveCallback=None,  errorCallback=None):
        self.setStatus ("Requête en cours..."+repr(event.eventtype))
        self.voteservice.request(event.request(self.token),  self)
        
        

if __name__ == '__main__':
    pyjd.setup("./MainMenu.html")
    panel = ContainerPanel()
    page = MainMenuPage(panel)
    panel.updateCenterPanel(page)
    RootPanel().add(panel)
    pyjd.run()
