# -*- coding: utf-8 -*-    

# Copyright 2009-2010 Manik Bhattacharjee (manik-listes at altern.org)
#                                                                
# This file is part of PyVotons!.                                
#                                                                
# PyVotons! is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or   
# (at your option) any later version.                                 
#                                                                     
# PyVotons! is distributed in the hope that it will be useful,        
# but WITHOUT ANY WARRANTY; without even the implied warranty of      
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       
# GNU Affero General Public License for more details.                        
#                                                                     
# You should have received a copy of the GNU Affero General Public License   
# along with PyVotons!.  If not, see <http://www.gnu.org/licenses/>. 

from pyjamas import Window
from pyjamas.ui.RootPanel import RootPanel
from pyjamas.ui.HorizontalPanel import HorizontalPanel
from pyjamas.ui.VerticalPanel import VerticalPanel
from pyjamas.ui.Button import Button
from pyjamas.ui import  HasAlignment
from pyjamas.ui.PasswordTextBox import PasswordTextBox
from pyjamas.ui.TextBox import TextBox
from pyjamas.ui.CheckBox import CheckBox
from pyjamas.ui.HTML import HTML
from pyjamas.ui.SimplePanel import SimplePanel
#from pyvotons.ui.pyjamas import ImageButton
#from pyvotons import core
#import MainMenuPage #ContainerPanel #pyvotons.ui.pyjamas.
#from pyvotons.ui.pyjamas import MainMenuPage
from pyvotons.core.event import Event

#import hashlib
#TODO : improve the layout
import pyjd

class NewUserPage (VerticalPanel):
    def __init__(self,  mainpanel = None,  token = None,  reallyNew = True,  userData=None):
        VerticalPanel.__init__(self)
		
        self.reallyNew=reallyNew
		
        if token is None:
            self.token = -1
        else:
            self.token = token
            
            if mainpanel is None:
                Window.alert("AuthPage : mainpanel is not valid !")
                return
        self.mainpanel = mainpanel
            
        if self.reallyNew:
			title = HTML("<h3><center>Create a new account</center></h3>")
			enterButton = Button("Create", self.createAccount)
        else:
			title = HTML("<h3><center>Update your personnal information</center></h3>")
			enterButton = Button("Update personnal information", self.createAccount)
        userLabel = HTML("Username")
        passwdLabel = HTML("Password")
        confirmPasswdLabel = HTML("Confirm Password")
        firstnameLabel = HTML("First name")
        lastnameLabel = HTML("Last name")
        emailLabel = HTML("E-mail")
        self.userText = TextBox()
        self.userText.setVisibleLength(20)
        self.userText.setMaxLength(40)
        self.passwdText = PasswordTextBox()
        self.confirmPasswdText = PasswordTextBox()
        self.firstnameText = TextBox()
        self.lastnameText = TextBox()
        self.emailText = TextBox()
        self.emailprivate= CheckBox("E-mail is private")
        self.emailprivate.setChecked(True)
		
		
        panel1 = HorizontalPanel()
        panel1.setBorderWidth(1)
        panel1.setHorizontalAlignment(HasAlignment.ALIGN_CENTER)
        panel1.setVerticalAlignment(HasAlignment.ALIGN_MIDDLE) 
        panel1.add(userLabel)
        panel1.add(self.userText)
        
        panel2 = HorizontalPanel()
        panel2.setBorderWidth(1)
        panel2.setHorizontalAlignment(HasAlignment.ALIGN_CENTER)
        panel2.setVerticalAlignment(HasAlignment.ALIGN_MIDDLE)
        panel2.add(passwdLabel)
        panel2.add(self.passwdText)
        
        panel3 = HorizontalPanel()
        panel3.setBorderWidth(1)
        panel3.setHorizontalAlignment(HasAlignment.ALIGN_CENTER)
        panel3.setVerticalAlignment(HasAlignment.ALIGN_MIDDLE)
        panel3.add(confirmPasswdLabel)
        panel3.add(self.confirmPasswdText)
        
        panel4 = HorizontalPanel()
        panel4.setBorderWidth(1)
        panel4.setHorizontalAlignment(HasAlignment.ALIGN_CENTER)
        panel4.setVerticalAlignment(HasAlignment.ALIGN_MIDDLE)
        panel4.add(firstnameLabel)
        panel4.add(self.firstnameText)
        
        panel5 = HorizontalPanel()
        panel5.setBorderWidth(1)
        panel5.setHorizontalAlignment(HasAlignment.ALIGN_CENTER)
        panel5.setVerticalAlignment(HasAlignment.ALIGN_MIDDLE)
        panel5.add(lastnameLabel)
        panel5.add(self.lastnameText)
        
        panel6 = HorizontalPanel()
        panel6.setBorderWidth(1)
        panel6.setHorizontalAlignment(HasAlignment.ALIGN_CENTER)
        panel6.setVerticalAlignment(HasAlignment.ALIGN_MIDDLE)
        panel6.add(emailLabel)
        panel6.add(self.emailText)
        
        self.add(title)
        self.add(panel1)
        self.add(panel2)
        self.add(panel3)
        self.add(panel4)
        self.add(panel5)
        self.add(panel6)
        self.add(self.emailprivate)
        self.add(enterButton)

    def wrongId(self,  sender):
        Window.alert("Username already exists")

    def unconfirmedPass(self):
        self.passwdText.setText("")
        self.confirmPasswdText.setText("")
        Window.alert("Passwords do not match ! Please type your password again")
        
    def success(self,  sender):
        Window.alert("Account successfully created !")
        self.mainpanel.send(Event("UI",  {"goto":"main" ,  "token":self.token}))
        #Window.alert("Login successful !")

    def connectUser(self,  login,  passwd):
        # SEND TO SERVER SIDE AND GET TOKEN
        #md5pass = hashlib.md5.new(passwd).hexdigest()  # DOES NOT WORK IN PYJAMAS
        #shapass = hashlib.sha256.new(passwd).hexdigest()
        answ = self.mainpanel.send(Event("authenticate", self.asDict()))
        self.add(HTML(answ))
        self.okOrNot = self.okOrNot + 1
        return self.okOrNot

    def authenticate(self,  sender):
        self.sessionId = self.connectUser(self.userText.getText(),  self.passwdText.getText())
        if self.sessionId < 3:
            self.wrongId()
        else:
            self.token = "ExampleToken1234567890"
            self.success()
			
    def asDict(self):
		return {'login':self.userText.getText(),  'pass':self.passwdText.getText(), \
		        'firstname':self.firstnameText.getText(),  'lastname':self.lastnameText.getText(),\
				'email':self.emailText.getText(),  'privateemail':self.emailprivate.isChecked()}
				
    def createAccount(self,  sender):
        if  self.passwdText.getText()  == self.confirmPasswdText.getText():
            if self.reallyNew:
              self.mainpanel.send(Event("createUser",  self.asDict()))
            else:
				self.mainpanel.send(Event("updateUser",  self.asDict()))
            #self.authenticate(None)
        else:
            self.unconfirmedPass()

