# -*- coding: utf-8 -*-

# Copyright 2009-2010 Manik Bhattacharjee (manik-listes at altern.org)
#                                                                
# This file is part of PyVotons!.                                
#                                                                
# PyVotons! is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or   
# (at your option) any later version.                                 
#                                                                     
# PyVotons! is distributed in the hope that it will be useful,        
# but WITHOUT ANY WARRANTY; without even the implied warranty of      
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       
# GNU Affero General Public License for more details.                        
#                                                                     
# You should have received a copy of the GNU Affero General Public License   
# along with PyVotons!.  If not, see <http://www.gnu.org/licenses/>. 

from pyjamas.ui.VerticalPanel import VerticalPanel
from pyjamas.ui.HorizontalPanel import HorizontalPanel
from pyjamas.ui.DisclosurePanel import DisclosurePanel
from pyjamas.ui.Label import Label
from pyjamas.ui.TextBox import TextBox
from pyjamas.ui.TextArea import TextArea
from pyjamas.ui.RichTextArea import RichTextArea
from pyjamas.ui.CheckBox import CheckBox
from pyjamas.ui.ListBox import ListBox
from pyjamas.ui.HTML import HTML
from pyjamas.ui.Button import Button
from pyjamas.ui.Grid import Grid

from pyjamas.ui.Calendar import DateField, Calendar, CalendarPopup

from pyjamas.ui.DragHandler import DragHandler
from pyjamas.dnd import makeDraggable
from pyjamas.ui.DragWidget import DragWidget, DragContainer
from pyjamas.ui.DropWidget import DropWidget
from pyjamas.dnd import getTypes
from pyjamas import DOM

#TODO DateTime doit devenir un Calendar + DateTime pour une saisie correcte des dates. Ajouter l'heure !

#class DateContainer(HorizontalPanel):
  #def dateChosen(self,y,m,d):
    #self.df.
  #def __init__(self):
    #self.df = DateField(format='%Y/%m/%d')
    #self.calButton = Button("Calendrier...", self)
    #self.cal = Calendar()
    #self.cal.addSelectedDateListener(self.dateChosen)
    #self.setSpacing(10)
    #self.add(self.df)
    #self.add(self.calButton)
    
  #def onClick(self, sender):
    #""" if the button ic clicked, pop-up the calendar"""
      #p = CalendarPopup(self.cal)
      #x = sender.getAbsoluteLeft() + 10
      #y = sender.getAbsoluteTop() + 10
      #p.setPopupPosition(x,y)
      #p.show()
    
  #def getDate(self)
    #return self.df.getDate()
    
def addWidgets(container, widg):
	widgets = {}
	for w in widg:
		panel = HorizontalPanel()
		if widg[w] != 'CheckBox':
			panel.add(HTML(w))
		if widg[w]=='TextBox':
			widgets[w] = TextBox()
		elif widg[w]=='RichTextArea':
			widgets[w] = TextArea()
		elif widg[w]=='CheckBox':
			widgets[w] = CheckBox(w)
		elif widg[w]=='ComboBox':
			widgets[w] = ListBox(VisibleItemCount=1)
		elif widg[w]=='DateTime':
			widgets[w] = DateField(format='%Y/%m/%d')
		elif widg[w]=='VerticalPanel':
			widgets[w] = VerticalPanel()
		else:
			widgets[w] = HTML("Unknown widget type "+repr(w))
		panel.add(widgets[w])
		container.add(panel)
	return widgets
	
def getWidgetsData(widgets,  widg):
	ret = {}
	for w in widg:
		print w
		widget = widgets[w]
		if widg[w]=='TextBox':
			ret[w] = widget.getText()
		elif widg[w]=='RichTextArea':
			ret[w] = widget.getText()
		elif widg[w]=='CheckBox':
			ret[w] = widget.isChecked()
		elif widg[w]=='DateTime': # Should be '2013-11-10 01:12:58'
			ret[w] = widget.getTextBox().getText()#getDate()
		else:# Raise exception ?
			ret['unknown']=w
	return ret

# Drag/drop widget classes : 
class DraggableAnswer(DragWidget, Label):
    """
      An answer that might be dragged to a DropZoneAnswer.
      Must be created with the text to display.
    """
    def __init__(self, txt):
        Label.__init__(self, Element=DOM.createElement('div'))
        self.setText(txt)
        self.answerText = txt
        DragWidget.__init__(self)
        self.setStyleName('pyvotons-draggable')

    def onDragStart(self, event):
        dt = event.dataTransfer
        dt.setData('Text', self.answerText)
        #dt.setDragImage(self.getElement(), 15, 15)
        dt.effectAllowed = 'copy'
        #self.addMessage('mode is %s' % dt.dataStore.items.mode)

    def onDragEnd(self, event):
        # if successful, grey-out ?
        pass


class DropZoneAnswer(DropWidget, Label):
    """ 
      Zone to where an answer should be dropped.
      Args should be the default text ("1st choice" for example) and a callback
      function that takes one argument and is called when something is dropped here
      If the answer is valid, setAnswer(content) should be called. To get back
      to the standard state, just call self.reset()
    """
    def __init__(self, text, name, dropCallback):
        Label.__init__(self, Element=DOM.createElement('div'))
        DropWidget.__init__(self)
        self.defaultText = text
        self.setText(self.defaultText)
        self.setStyleName('pyvotons-dropable')
        self.name = name
        self.dropCallback = dropCallback
      
    def reset(self):
        self.setText(self.defaultText)
        self.setStyleName('pyvotons-dropable')

    def setAnswer(txt):
      self.setText(txt)
      self.setStyleName('pyvotons-dropped')
      
    def onDragEnter(self, event):
        self.addStyleName('dragover')
        DOM.eventPreventDefault(event)

    def onDragLeave(self, event):
        self.removeStyleName('dragover')

    def onDragOver(self, event):
        DOM.eventPreventDefault(event)

    def onDrop(self, event):
        dt = event.dataTransfer
        #'text', 'text/plain', and 'Text' are equivalent.
        try:
            item = dt.getData("text/plain")
            self.dropCallback(name, item)
            self.setText(item)
        except:
            pass

        DOM.eventPreventDefault(event)
        #DOM.eventStopPropagation(event)



class OrderQuestionPanel(VerticalPanel):
    def dropReceived(self, name, value){
	  num = int(name)
	  self.rankedAnswers[num]=value # rankedAnswers[2] = "MonChoix"
	
    def __init__(self,  question):
        VerticalPanel.__init__(self)
        # Sanity checks
        if 'questionType' not in question or question['questionType'] != "Order":
            self.add(HTML("<h1>Erreur ! La question n'est pas du type Order</h1>"))
            return
        self.add(HTML(question['title']))
        self.add(HTML(question['description']))
        self.rankedAnswers={}
          
        num = 1
        hp = HorizontalPanel()
        vp1 = VerticalPanel()
        vp2 = VerticalPanel()
        for answer in question['answers']:
          drop = DropZoneAnswer(u"Réponse "+str(num), num, self.dropReceived)
          drag = DraggableAnswer(answer)
          vp1.add(drag)
          vp2.add(drop)
          num += 1
        hp.add(vp1)
        hp.add(vp2)
        self.add(hp)
		# Should use a drag and drop interface : placeholders should receive (link) answers from a list of possible answers
		# See DND pyjamas example and http://osdir.com/ml/general/2011-03/msg04288.html
		#
		# Summary : 
		
		#Use the provided pyjamas.ui.DragWidget and pyjamas.ui.DropWidget widgets
		#as mix-ins to your widgets. ÂOn the drag side, a DragWidget will make
		#itself draggable; a DragContainer may contain a number of individually
		#draggable widgets.
		#
		#Use the HTML5 drag-and-drop api. ÂThere are seven events involved, which
		#means making onXXX methods for your widgets. There are three on the drag
		#side (onDragStart, onDrag, onDragEnd) and four on the drop side
		#(onDragEnter, onDragOver, onDragLeave, onDrop).
		
		
		# Is this ordered ? Must all answers be entered to get a valid vote ? Or just ordering some candidates is ok ?
		# ANYHOW store the result as a dictionary  (rank:candidata, rank2:candidate2)
		# FIXME : do not accept the same candidate at multiple ranks
		# FIXME : MUST add a way to reset the choices
    def status(self):
      return self.rankedAnswers
    
# Create a title, description, type='Order' and answers list
class OrderQuestionPanelEditor(VerticalPanel):
	def __init__(self,  question):
		VerticalPanel.__init__(self)
		self.add(HTML("Order QUESTION EDITOR"))
		self.widg={'title':'TextBox',  'description':'RichTextArea',  'algo':'ComboBox','answersPanel':'VerticalPanel'}
		self.widgets = addWidgets(self,  self.widg)
		for i in ['Majority', 'SingleTransferableVote', 'MeanOrder',  'MedianOrder']:
			self.widgets['algo'].addItem(i)
		questionButtonsPanel = HorizontalPanel()
		questionButtonsPanel.add(Button("Add an answer",  self.addAnswer))
		questionButtonsPanel.add(Button("Remove selected answers",  self.removeSelectedAnswers))
		self.add(self.widgets['answersPanel'])
		self.add(questionButtonsPanel)
		self.answers = []
		
	def addAnswer(self):
		a = (CheckBox(),  TextBox('Answer text'),  HorizontalPanel())
		self.answers.append(a)
		hp = a[2]
		hp.add(a[0])
		hp.add(a[1])
		self.widgets['answersPanel'].add(hp)
		
	def removeSelectedAnswers(self):
		for a in self.answers:
			if a[0].isChecked():
				self.widgets['answersPanel'].remove(a[2]) 
		self.answers = [a for a in self.answers if not a[0].isChecked() ]
		
	def getAnswers(self):
		return [a[1].getText() for a in self.answers]
	
	def __repr__(self):
		return {'questionType':'Order',  'title':self.widgets['title'].getText(),  'algo':self.widgets['algo'].getSelectedItemText()[0],  'description':self.widgets['title'].getText(), 'answers':self.getAnswers()}

class OrderQuestionResultPanel(VerticalPanel):
    def __init__(self,  question,  displayMode = 'full'):
        VerticalPanel.__init__(self)
        # Sanity checks
        if 'questionType' not in question or question['questionType'] != "Order":
            self.add(HTML("<h1>Erreur ! La question n'est pas du type Order</h1>"))
            return
        # Display mode
        if displayMode == 'full':
            self.fullResults(question)
        else:
            self.shortResults(question)
    
    def fullResults(self,  question):
        VerticalPanel.clear(self)
        self.add(HTML(question['title']))
        grid = Grid(2, len(question['answers']),
                    BorderWidth=2,
                    CellPadding=4,
                    CellSpacing=1)
        idx = 0
        for (answer, res) in question['results']:
            if (answer,  res) in question['winners']:
                grid.setHTML(0,  idx, "<font color='green'>"+answer+"</font>")
            else:
                grid.setHTML(0,  idx, answer)
                
            grid.setHTML(1, idx, str(res))
            idx += 1
        
        self.add(grid)
        disc = DisclosurePanel('Details')
        disc.setHeader(HTML("<b>Détails du calcul...</b>"))
        disc.setContent(HTML(question['explanation']))
        self.add(disc)
        
    def shortResults(self,  question):
        VerticalPanel.clear(self)
        self.add(HTML(question['title']))
        grid = Grid(2, len(question['winners']),
                    BorderWidth=2,
                    CellPadding=4,
                    CellSpacing=1)
        idx = 0
        for (answer,  res) in question['winners']:
            grid.setHTML(0,  idx, "<font color='green'>"+answer+"</font>")
            grid.setHTML(1, idx, str(res))
            idx += 1
        self.add(grid)
