# -*- coding: utf-8 -*-

# Copyright 2009-2010 Manik Bhattacharjee (manik-listes at altern.org)
#                                                                
# This file is part of PyVotons!.                                
#                                                                
# PyVotons! is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or   
# (at your option) any later version.                                 
#                                                                     
# PyVotons! is distributed in the hope that it will be useful,        
# but WITHOUT ANY WARRANTY; without even the implied warranty of      
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       
# GNU Affero General Public License for more details.                        
#                                                                     
# You should have received a copy of the GNU Affero General Public License   
# along with PyVotons!.  If not, see <http://www.gnu.org/licenses/>. 

from pyjamas import Window
from __pyjamas__ import JS
from pyjamas.ui.RootPanel import RootPanel
from pyjamas.ui.VerticalPanel import VerticalPanel
from pyjamas.ui.HorizontalPanel import HorizontalPanel
from pyjamas.ui.Button import Button
from pyjamas.ui.HTML import HTML
from pyjamas.ui.TextBox import TextBox

from pyvotons.core.event import Event
from pyvotons.core.sanitize import *
from pyvotons.ui.pyjamas.ChooseQuestionPanel import ChooseQuestionPanel
from pyvotons.ui.pyjamas.SelectQuestionPanel import SelectQuestionPanel
from pyvotons.ui.pyjamas.OrderQuestionPanel import OrderQuestionPanel
from pyvotons.ui.pyjamas.RateQuestionPanel import RateQuestionPanel

import pyjd

# TODO this class uses an obsolete communication API - should use callback functions


## This class displays a Panel allowing to vote (stand-alone or inside a ContainerPanel)

class QuickVote  (VerticalPanel):
	def vote(self):
        # Verifier la validité du vote : check and registerVote
		answers = [p.status() for p in self.questionPanels]
		#userName = sanitizeAlphanumSpace(self.userNameText.getText())
		self.mainpanel.send(Event("checkAndRegisterVote",  {"scrutin":self.scrutin,  "vote":answers}))
        

	def __init__(self,  mainpanel = None,  voteId = None,  scrutin=None):
		VerticalPanel.__init__(self,  StyleName="pyv-PageBody")
		self.mainpanel = mainpanel
        
		if scrutin is not None:
			self.displayVote(scrutin)
			return
#      Récupérer l'URL et le paramètre voteId
		if voteId is None:
			myDic = Window.getLocation().getSearchDict()
			if "voteId" in myDic:
				voteId = myDic["voteId"]
			else:
				self.add(HTML("<h2>Identifiant du vote invalide !</h2>")) 
				return
				
		try:
			voteId = sanitizeAlphanum(voteId)
			self.loadScrutin(voteId)
		except:
			self.add(HTML("Impossible d'accéder à ce scrutin !"))
			return
			
	def displayVote(self,  scrutin):
	        self.scrutin = scrutin
		# Créer les panneaux correspondant aux types des questions
	        panelBuilder = {'Choose': lambda  q: ChooseQuestionPanel(q), \
	                        'Select': lambda q: SelectQuestionPanel(q), \
	                        'Rate':lambda q: RateQuestionPanel(q), \
	                        'Order':lambda q: OrderQuestionPanel(q)}
	                        
	        self.add(HTML("<h1>Votez pour le scrutin %s</h1>" % (scrutin['title'])))
	        
	        # Username  
#	        self.userNameText = TextBox()
#	        hp = HorizontalPanel()
#	        hp.add(HTML("Nom : "))
#	        hp.add(self.userNameText)
#	        self.add(hp)
	        
	        # Displaying the questions
	        self.questionPanels = []
	        for ques in scrutin['questions']:
	            if ques['questionType'] in panelBuilder:
	                p = panelBuilder[ques['questionType']](ques)
	                self.add(p)
	                self.questionPanels.append(p)
	            else:
	                self.add(HTML("Question de type invalide ! - ignorée"))
	       
	        
	        self.add(Button("Voter",  self.vote))
		
	def loadScrutin(self,  scrutinid):
		# Send a message to get the scrutin
		pass
		
	def finishLoadScrutin(self,  answer):
		self.displayVote(answer['scrutin'])

	def finishVote(self,  ok,  errstr):
		if ok:
			Window.alert("Vote enregistré !")
			Panel.clear()
			self.mainpanel.send(Event("UI",  {"goto":"main"}))
		else:
			msg = result['errMsg']
			Window.alert("Erreur : le vote n'a pas été enregistré !<br> %s" % (errstr))
        	# If invalid, get the list of invalid answers and color them in red using self.questionPanels
            	# and result['invalidQuestions']






if __name__ == '__main__':
    pyjd.setup("./QuickVote.html")
    RootPanel().add(QuickVote())
    pyjd.run()
    
