# -*- coding: utf-8 -*-    

# Copyright 2009-2010 Manik Bhattacharjee (manik-listes at altern.org)
#                                                                
# This file is part of PyVotons!.                                
#                                                                
# PyVotons! is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or   
# (at your option) any later version.                                 
#                                                                     
# PyVotons! is distributed in the hope that it will be useful,        
# but WITHOUT ANY WARRANTY; without even the implied warranty of      
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       
# GNU Affero General Public License for more details.                        
#                                                                     
# You should have received a copy of the GNU Affero General Public License   
# along with PyVotons!.  If not, see <http://www.gnu.org/licenses/>. 

from pyjamas import Window
from pyjamas.ui.RootPanel import RootPanel
from pyjamas.ui.HorizontalPanel import HorizontalPanel
from pyjamas.ui.VerticalPanel import VerticalPanel
from pyjamas.ui.Button import Button
from pyjamas.ui import  HasAlignment
from pyjamas.ui.PasswordTextBox import PasswordTextBox
from pyjamas.ui.TextBox import TextBox
from pyjamas.ui.HTML import HTML
from pyjamas.ui.SimplePanel import SimplePanel
#from pyvotons.ui.pyjamas import ImageButton
#from pyvotons import core
#import MainMenuPage #ContainerPanel #pyvotons.ui.pyjamas.
#from pyvotons.ui.pyjamas import MainMenuPage
from pyvotons.core.event import Event

#import hashlib

import pyjd

class AuthPage (VerticalPanel):
    def __init__(self,  mainpanel = None,  token = None):
        VerticalPanel.__init__(self,  StyleName="pyv-PageBody")

        self.okOrNot = 1
        if token is None:
            self.token = -1
        else:
            self.token = token
            
        if mainpanel is None:
            Window.alert("AuthPage : mainpanel is not valid !")
            return
        self.mainpanel = mainpanel
            
        title = HTML("<h3><center>Please connect using your username and password :</center></h3>")
        userLabel = HTML("Username")
        passwdLabel = HTML("Password")
        self.userText = TextBox()
        self.userText.setVisibleLength(20)
        self.userText.setMaxLength(10)
        self.passwdText = PasswordTextBox()
        
        panel1 = HorizontalPanel()
        panel1.setBorderWidth(1)
        panel1.setHorizontalAlignment(HasAlignment.ALIGN_CENTER)
        panel1.setVerticalAlignment(HasAlignment.ALIGN_MIDDLE) 
        panel1.add(userLabel)
        panel1.add(self.userText)
        
        panel2 = HorizontalPanel()
        panel2.setBorderWidth(1)
        panel2.setHorizontalAlignment(HasAlignment.ALIGN_CENTER)
        panel2.setVerticalAlignment(HasAlignment.ALIGN_MIDDLE)
        panel2.add(passwdLabel)
        panel2.add(self.passwdText)
        
        enterButton = Button("Enter", self.authenticate)
        newUserButton = Button("Create a new account", self.newAccount)
        
        self.add(title)
        self.add(panel1)
        self.add(panel2)
        self.add(enterButton)
        self.add(newUserButton)

    def wrongId(self,  sender):
        Window.alert("Username or password incorrect !")


    def newAccount(self,  sender):
        #self.mainpanel.send(Event("auth",  {"action":"login", "token":self.token }))
        self.mainpanel.send(Event("UI",  {"goto":"newuser" ,  "token":self.token}))

    def success(self,  sender):
        #self.mainpanel.send(Event("auth",  {"action":"login", "token":self.token }))
        self.mainpanel.setStatus("Authentication OK")
        self.mainpanel.send(Event("UI",  {"goto":"main" ,  "token":self.token}))
        #Window.alert("Login successful !")
    def connectCallback(self, answ):
        # Check error or success
        # If success, just set the mainpanel token and go to the main menu
	if answ['status'] == 'success':
          self.mainpanel.setToken(answ['result']['token'])
          self.success()
        else:
          if 'error' in answ:
            self.mainpanel.setStatus('<font color="red">Authentication failed :'+answ['error']+'</font>')
          else:
            self.mainpanel.setStatus('<font color="red">Authentication failed (unknown reason)</font>')

    def connectUser(self,  login,  passwd):
        # SEND TO SERVER SIDE AND GET TOKEN
        #md5pass = hashlib.md5.new(passwd).hexdigest()  # DOES NOT WORK IN PYJAMAS
        #shapass = hashlib.sha256.new(passwd).hexdigest()
        #answ = Event("authenticate", {'login':login,  'pass':passwd}).send()
        self.mainpanel.send(Event("authenticate", {'action':'login','login':login,'pass':passwd}))
        if answ is not None:
            self.add(HTML(answ))
        self.okOrNot = self.okOrNot + 1
        return self.okOrNot

    def authenticate(self,  sender):
        #self.add(HTML("AUTHENTICATE CALLED..."))
        self.mainpanel.setStatus("Authentication in progress...")
        self.connectUser(self.userText.getText(),  self.passwdText.getText())



def AppInit():
    return AuthPage()


#if __name__ == '__main__':
#    pyjd.setup("./auth.html")
#    panel = MainMenuPage.ContainerPanel()
#    auth = AppInit(panel,  -1)
#    panel.updateCenterPanel(auth)
#    RootPanel().add(panel)
#    pyjd.run()
